package com.kingsrook.qqq.backend.core.model.dashboard.widgets;


import java.util.List;


/*******************************************************************************
 **
 *******************************************************************************/
public class BarChart
{

   /*
      type: "barChart",
         title: "Parcel Invoice Lines per Month",
         barChartData: {
            labels: ["Feb 22", "Mar 22", "Apr 22", "May 22", "Jun 22", "Jul 22", "Aug 22"],
            datasets: {label: "Parcel Invoice Lines", data: [50000, 22000, 11111, 22333, 40404, 9876, 2355]},
         },
    */

   private String type = "barChart";
   private String title;
   private Data   barChartData;



   /*******************************************************************************
    **
    *******************************************************************************/
   public BarChart(String title, String seriesLabel, List<String> labels, List<Number> data)
   {
      setTitle(title);
      setBarChartData(new BarChart.Data()
         .withLabels(labels)
         .withDatasets(new BarChart.Data.DataSet()
            .withLabel("Parcel Invoice Lines")
            .withData(data)));
   }



   /*******************************************************************************
    ** Getter for title
    **
    *******************************************************************************/
   public String getTitle()
   {
      return title;
   }



   /*******************************************************************************
    ** Setter for title
    **
    *******************************************************************************/
   public void setTitle(String title)
   {
      this.title = title;
   }



   /*******************************************************************************
    ** Fluent setter for title
    **
    *******************************************************************************/
   public BarChart withTitle(String title)
   {
      this.title = title;
      return (this);
   }



   /*******************************************************************************
    ** Getter for barChartData
    **
    *******************************************************************************/
   public Data getBarChartData()
   {
      return barChartData;
   }



   /*******************************************************************************
    ** Setter for barChartData
    **
    *******************************************************************************/
   public void setBarChartData(Data barChartData)
   {
      this.barChartData = barChartData;
   }



   /*******************************************************************************
    ** Fluent setter for barChartData
    **
    *******************************************************************************/
   public BarChart withBarChartData(Data barChartData)
   {
      this.barChartData = barChartData;
      return (this);
   }



   /*******************************************************************************
    ** Getter for type
    **
    *******************************************************************************/
   public String getType()
   {
      return type;
   }



   /*******************************************************************************
    ** Setter for type
    **
    *******************************************************************************/
   public void setType(String type)
   {
      this.type = type;
   }


   /*******************************************************************************
    ** Fluent setter for type
    **
    *******************************************************************************/
   public BarChart withType(String type)
   {
      this.type = type;
      return (this);
   }



   /*******************************************************************************
    **
    *******************************************************************************/
   public static class Data
   {
      private List<String> labels;
      private DataSet      datasets;



      /*******************************************************************************
       ** Getter for labels
       **
       *******************************************************************************/
      public List<String> getLabels()
      {
         return labels;
      }



      /*******************************************************************************
       ** Setter for labels
       **
       *******************************************************************************/
      public void setLabels(List<String> labels)
      {
         this.labels = labels;
      }



      /*******************************************************************************
       ** Fluent setter for labels
       **
       *******************************************************************************/
      public Data withLabels(List<String> labels)
      {
         this.labels = labels;
         return (this);
      }



      /*******************************************************************************
       ** Getter for datasets
       **
       *******************************************************************************/
      public DataSet getDatasets()
      {
         return datasets;
      }



      /*******************************************************************************
       ** Setter for datasets
       **
       *******************************************************************************/
      public void setDatasets(DataSet datasets)
      {
         this.datasets = datasets;
      }



      /*******************************************************************************
       ** Fluent setter for datasets
       **
       *******************************************************************************/
      public Data withDatasets(DataSet datasets)
      {
         this.datasets = datasets;
         return (this);
      }



      /*******************************************************************************
       **
       *******************************************************************************/
      public static class DataSet
      {
         private String       label;
         private List<Number> data;



         /*******************************************************************************
          ** Getter for label
          **
          *******************************************************************************/
         public String getLabel()
         {
            return label;
         }



         /*******************************************************************************
          ** Setter for label
          **
          *******************************************************************************/
         public void setLabel(String label)
         {
            this.label = label;
         }



         /*******************************************************************************
          ** Fluent setter for label
          **
          *******************************************************************************/
         public DataSet withLabel(String label)
         {
            this.label = label;
            return (this);
         }



         /*******************************************************************************
          ** Getter for data
          **
          *******************************************************************************/
         public List<Number> getData()
         {
            return data;
         }



         /*******************************************************************************
          ** Setter for data
          **
          *******************************************************************************/
         public void setData(List<Number> data)
         {
            this.data = data;
         }



         /*******************************************************************************
          ** Fluent setter for data
          **
          *******************************************************************************/
         public DataSet withData(List<Number> data)
         {
            this.data = data;
            return (this);
         }
      }
   }
}
